proc enter

  CLEAR
  IF (WordTech)
    WSET WIND datawin to 7,5,18,75 color w+/b,b/w,w
    WSELECT 99
    WUSE datawin TITLE " Help generation "
  ENDIF

  DO WHILE (.NOT. EOF())
    STORE SPACE(254) to helptext
    STORE SPACE(254) to valid
    DO edit with RTRIM(field_name),helptext,valid
    SELECT 10
    APPEND BLANK
    REPLACE field with gentemp->field_name
    REPLACE helptext with m->helptext
    REPLACE valid with m->valid
    SELECT 9
    SKIP
  ENDDO

  IF (WordTech)
    WCLOSE
  ENDIF
  RETURN

proc edit
  parameters name,helptext,valid

  PRIVATE more_entry,error_cnt,help1,help2,help3,help4
  more_entry = .T.
  error_cnt = 0
  SELECT 1
  DO WHILE (more_entry)
    STORE SPACE(26) TO help1,help2,help3,help4
    @ 1,0
    @ 1,0 SAY 'Please enter help text for field "&name" below:'
    @ 2,0 GET help1
    @ 3,0 GET help2
    @ 4,0 GET help3
    @ 5,0 GET help4
    @ 6,0
    @ 6,0 SAY 'Please enter validation expresson for field "&name" below:'
    @ 7,0 GET valid
    READ
    IF (len(RTRIM(valid)) > 0)
      DO WHILE (type(RTRIM(valid)) <> 'L')
        error_cnt = error_cnt + 1
        IF (type(RTRIM(valid)) = 'U')
          DO say_msg WITH "Invalid validation expression please re-enter..."," ERROR "
        ELSE
          DO say_msg WITH "Expression must be logical." ," ERROR "
        ENDIF
        @ 7,0 GET valid
        READ
        IF (error_cnt > 2)
          DO say_msg WITH "Giving up on this field moving on to next." ," INFORMATION "
          valid = SPACE(len(valid))
          EXIT
        ENDIF
      ENDDO
    ENDIF
    more_entry = .F.
  ENDDO
  newline = CHR(13)+CHR(10) + " "
  helptext = newline + RTRIM(help1) + newline+ RTRIM(help2) + newline + RTRIM(help3) + newline + RTRIM(help4)
  RETURN

proc say_msg
PARAMETERS message,title
  PRIVATE firstrow

  IF (WordTech)
    WSET WIND errorwin to 18,1,23,78 color w+/r,r/w+,w
    WSELECT 99
    WUSE errorwin TITLE title
    firstrow = 1
  ELSE
    firstrow = 22
  ENDIF

  @ firstrow,0
  @ firstrow,0 SAY message
  ?
  WAIT
  @ firstrow,0
  @ firstrow+2,0
  IF (WordTech)
    WCLOSE
  ENDIF
  RETURN
